# DataTurbine Capture Utility

# rbnbCapture

# User Manual

## V1.3

## April 10, 2002

## Copyright, Creare Inc.

## Table of Contents

> ### Introduction

> > Overview
> > Setup and Startup

> ### Command Line Arguments

> > DataTurbine
> > Data Path
> > Channel
> > Cache Size
> > Archive Size
> > Input Socket
> > Autorun
> > Use Settings File
> > Usage Information

> ### User Interface Fields

> > Start Button
> > Stop Button
> > MenuBar

> > > File

> > > > Open
> > > > Socket
> > > > Close
> > > > Exit

> > > Data

> > > > Target
> > > > Settings

# Introduction

## Overview

The rbnbCapture utility acquires unicast or multicast UDP datagram packets (not TCP streams) and puts them into one or more DataTurbines. One use for this is to acquire live video from a digital camera attached to a computer.

The rbnbCapture application provides a simple command line interface and displays acquisition statistics in a pop-up window.

The following figure shows an example rbnbCapture statistics display.

Example rbnbCapture Statistics Display

## Setup and Startup

The rbnbCapture application needs to be run under a Java Virtual Machine (JVM). Different flavors of Java come by different names (e.g. java, jre, jview).

The user may initialize rbnbCapture's settings and start the utility from the command line, or the user may start rbnbCapture with default settings from the Applications menu of rbnbManager. If a file named "CaptureSettings.dat" exists in the directory from which rbnbManager is run, rbnbCapture will use it to store and retrieve its settings from one session to the next.

# Command Line Arguments

## DataTurbine

-r [RBNB host][:RBNB port]

The data is sent to the specified DataTurbine.

The default DataTurbine is localhost:3333.

## Data Path

-D datapath

The data is stored in the data path. The data path is the name of a directory (UNIX) or folder (Windows/Mac) under the DataTurbine's home directory.

The default data path is automatically assigned by the DataTurbine. It consists of the host name of the machine running the rbnbCapture program, a dot, and a uniquely assigned number: "<host server>.<unique number>".

## Channel

-c name

The data is stored in the DataTurbine under the specified channel name.

The default channel name is "VIDEO".

## Cache Size

-C cachesize

Specifies the maximum number of frames of data stored in the DataTurbine's ring buffer cache. The DagtaTurbine frames are built from one or more datagram packets, with each packet being assigned an interval in the frame time-stamp with a start time equal to the time the packet was acquired by rbnbCapture.

The default is 10,000 frames.

## Archive Size

-A archivesize

Specifies the maximum number of frames of data stored in the DataTurbine's ring buffer archive. The DataTurbine frames are built from one or more datagram packets, with each packet being assigned an interval in the frame time-stamp with a start time equal to the time the packet was acquired by rbnbCapture.

By default archiving is on, and the archive is 100,000 frames.

## Input Socket

-p [IP address][:port]

Specifies the UDP address of the input datagram packet socket. See below for more details.

## Autorun

-a

Causes rbnbCapture to begin capturing UDP packets immediately upon start-up.

## Use Settings File

-f

This argument signals rbnbCapture to use the file named "CaptureSettings.dat" to store and retrieve its settings. The file must already exist in the directory from which rbnbCapture is run.

## Usage Information

-?

Does not start the rbnbCapture application, but causes it to display its command line usage information.

# User Interface Fields

## Start Button

The Start Button serves to begin the capture of data into a DataTurbine.

## Stop Button

The Stop button halts the capture of data.

## MenuBar

### File Menu

The File menu contains buttons which permit the user to specify a DataTurbine to capture data into (Open), to designate a socket to capture data from (Socket), to close the open connection (Close), and to exit the program (Exit).

#### Open...

The Open button displays a dialog in which the user may specify which DataTurbines to connect to and store data in. The user should enter the DataTurbine names in the format <host>:<port>. By default, the DataTurbine is "localhost:3333".

The following is an example of the hosts dialog:

Example rbnbCapture Hosts Dialog

#### Socket

The Socket button is used to configure the Socket from which rbnbCapture will receive its data. It pops the following dialog box in which the user may enter the IP address and port number.

Example rbnbCapture Socket Dialog

The input socket may have a unicast, broadcast, or multicast UDP address plus a port.

Unicast addresses specify a single interface of a particular host for one-to-one communication. To listen on a unicast port, specify the local host, i.e. either 127.0.0.1 or a specific local interface IP address. A remote sender then opens this address to send data. Messages are delivered to the first receiver listening on that interface and port, so typically you will want to select a unique port.

Broadcast addresses specify all hosts on a specific network. Messages are delivered to everyone listening on that network and port. Broadcast addresses have the form xxx.xxx.xxx.255, as described in RFC1122 (they talk about host -1, which translates to 255 in the standard dotted IP address format used here).

Multicast addresses specify all hosts in a specific multicast group. Messages are delivered to everyone listening to that multicast group and port. Multicast addresses are in the range 224.0.0.0 to 239.255.255.255 as described in RFC1112.

The input address is parsed to determine if the socket is unicast, broadcast, or multicast.

The default IP address is the IP address of the host computer, a unicast address. The default port number is 4444.

#### Close

The Close button will close the current connection to the DataTurbine.

#### Exit

The Exit button stops rbnbCapture, closes all of its connections, and exits the program.

### Data Menu

The Data Menu gives the user opportunity to change the datapath and channel name where the data is being stored within the connected DataTurbine (Target), and to determine the cache and archive sizes and the rate of data transfer (Settings).

#### Target

The Target button pops a dialog which lets the user specify the target locations for the captured data. The user may set the datapath and channel where the data will be stored within the DataTurbine. The same datapath and channel names are used on all of the output servers. By default, the datapath and channel are both set to "VIDEO". If no datapath is specified the DataTurbine will choose a unique datapath.

The following is an example of the Target Dialog.

Example rbnbCapture Target Dialog

#### Settings

The Settings button pops a dialog with options for entering the cache and archive sizes and the rate for data transfer. The cache must be at least 1 frame in size. By default it is 10,000 frames. If the archive size is set to 0, then archiving will be turned off. By default, the archive size is 100,000 frames, and archiving is on.

The following is an example of the Settings Dialog.

Example rbnbCapture Settings Dialog